设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 92|回复: 7

[求助] 多边形选择集遇到的奇怪问题

[复制链接]
发表于 2019-4-30 17:28:09 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
本帖最后由 CAD之路 于 2019-4-30 17:35 编辑

请点击此处下载

查看状态:需购买或无权限

您的用户组是:游客

文件名称:新块1.rar 
下载次数:0  文件大小:15.38 KB 
下载权限: 不限 以上  [免费赚D豆]



利用多边形选择集选择位于多边形和穿过多边形的对象,结果发现总有几根数据,无论怎么样都选择不了,选不中的数据见附件图形中的白色线。运行环境:VBA+Autocad2008.后测试,c#同样存在该问题。麻烦各位大神分析一下原因和解决方法。图形数据见附件CAD文件。
代码如下:
[Actionscript3] 纯文本查看 复制代码
Sub SelPl()
      ' On Error Resume Next
     Dim objSelect As AcadEntity
    Dim basePnt As Variant
    Dim objAdd As AcadEntity
    Dim lw As AcadLWPolyline
    Dim sss As AcadSelectionSet
    Set sss = CreateSelectionSet("zz")


    ThisDrawing.Utility.GetEntity objSelect, basePnt, vbCrLf & "请选择多边形:"
   
     
    Dim k1 As Integer
    Dim k As Integer
    Dim pointarrays() As Double
    Dim i As Integer
    
    
    Set lw = objSelect
     k = UBound(lw.Coordinates)
    k1 = (k + 1) * 1.5
    
    
        ReDim pointarrays(0 To k1 - 1)
    For i = 0 To k1 / 3 - 1 Step 1                  '把坐标赋值给数组
         pointarrays(i * 3) = lw.Coordinates(i * 2)
         pointarrays(i * 3 + 1) = lw.Coordinates(i * 2 + 1)
         pointarrays(i * 3 + 2) = 0
    Next
    
   
    ThisDrawing.Application.ZoomExtents
    sss.Clear
    sss.SelectByPolygon acSelectionSetCrossingPolygon, pointarrays
    
    For Each objAdd In sss
    
       objAdd.color = 30
    Next
End Sub

Private Function CreateSelectionSet(Optional SSetName As String) As AcadSelectionSet
    On Error Resume Next
    ThisDrawing.SelectionSets(SSetName).Delete
    Set CreateSelectionSet = ThisDrawing.SelectionSets.Add(SSetName)
End Function
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 1938个

财富等级: 堆金积玉

发表于 2019-5-1 03:21:58 | 显示全部楼层
谢谢楼主分享
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 19个

财富等级: 恭喜发财

发表于 2019-5-1 11:52:29 | 显示全部楼层
把所有的对象都显示到屏幕内
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

 楼主| 发表于 2019-5-1 22:01:05 | 显示全部楼层
这个肯定哦,在选择集创建前,已经做了:ThisDrawing.Application.ZoomExtents  这个操作了!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

 楼主| 发表于 2019-5-1 22:05:43 | 显示全部楼层
本帖最后由 CAD之路 于 2019-5-1 22:10 编辑

就没有人遇到过吗?或者用我传的数据直接测试一下?
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 19个

财富等级: 恭喜发财

发表于 2019-5-2 14:03:17 | 显示全部楼层
本帖最后由 Lisphk 于 2019-5-2 14:04 编辑
CAD之路 发表于 2019-5-1 22:05
就没有人遇到过吗?或者用我传的数据直接测试一下?

手工在CAD下面,能选择到吗?另外,点表别有重点
你打印下点表看看

点评

这些肯定没有问题哦  发表于 2019-5-3 13:36
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

 楼主| 发表于 2019-5-3 17:47:08 | 显示全部楼层
这些肯定没有问题哦.都考虑过了
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2019-5-21 12:35 , Processed in 0.148484 second(s), 37 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

© 2001-2017 Comsenz Inc.

快速回复 返回顶部 返回列表